/* -*- Mode: C++; -*- */
/* "VER: $Id: Effects.c,v 1.1 2003/09/02 19:24:49 olethros Exp $" */

#include "Effects.h"

Effect::Effect()
{
     params = NULL;
     in = NULL;
     out = NULL;
}

Effect::~Effect()
{
     if (params)
     {
	  DeleteVector (params);
     }
}

int Effect::SetInput (TimedStream* s)
{
     if (s) {
	  in = s;
	  return 0;
     }
     return DEC_ARG_INVALID;
}

int Effect::SetOutput (TimedStream* s)
{
     if (s) {
	  out = s;
	  return 0;
     }
     return DEC_ARG_INVALID;
}

TimedStream* Effect::GetOutput (void)
{
     return out;
}

Echo::Echo()
{
     params = NewVector (8);
}

Echo::~Echo()
{
     DeleteVector (params);
}

int Echo::Apply (void)
{
     return -1;
}
