/* -*- Mode: C++; -*- */
/* "VER: $Id: Effects.h,v 1.1 2003/09/02 19:24:49 olethros Exp $" */

#ifndef EFFECTS_H
#define EFFECTS_H

#include "TimedStreams.h"
#include "Vector.h"

class Effect
{
protected:
     Vector* params;
     TimedStream* in;
     TimedStream* out;
public:
     Effect();
     virtual ~Effect();
     virtual int Apply(void) = 0;
     virtual int SetInput (TimedStream* s);
     virtual int SetOutput (TimedStream* s);
     virtual TimedStream* GetOutput (void);
};

/* Echo has the following parameters;
   params->x[0] - delay time in ms.
   params->x[1] - decay rate, should be in (0,1).
 */
class Echo : public Effect
{
public:
     Echo();
     virtual ~Echo();
     virtual int Apply (void);
};

#endif /* EFFECTS_H */
