/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* VER: $Id: ISOLearning.h,v 1.1 2003/07/29 01:22:00 olethros Exp $ */

#ifndef ISOLEARNING_H
#define ISOLEARNING_H

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "debug.h"
#include "util.h"
#include "List.h"
#include "real.h"

typedef struct SpringMass_ {
	real a; //acceleration;
	real u; //speed
	real x; //offset
	real d; //damping
	real k; //spring strength
} SpringMass;

typedef struct ISOFilter_ {
	real (*f) (struct ISOFilter_*, real* x, real dt); //Transfer function
	real* p; //parameters of the transfer function;
	real u; //filter output
} ISOFilter;

typedef struct ISOLearner_ {
	int n_inputs;
	int n_outputs;
	int n_filters;
	real* x;
	real* u;
	real* y;
	ISOFilter* h;
	real* w;
	real dt;
} ISOLearner;

ISOLearner* NewISOLearner (int n_inputs, int n_outputs, int n_filters, real dt);
int FreeISOLearner (ISOLearner* iso);
int NewISOFilter (ISOFilter* h, int n_inputs);
void ISOLearner_Input (ISOLearner* iso, real* x);
real ISOFilterInput (struct ISOFilter_* h, real*x, real dt);
#endif /* ISOLEARNING_H */
