#ifndef LINKEDLIST_H
#define LINKEDLIST_H

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "debug.h"

#undef DEBUG_LINKEDLIST

typedef struct sBuffer {
  void* data;
  long len;
} BUFFER;


typedef struct sListNode {
  BUFFER* data;
  struct sListNode* next;
  long ID;
} LISTNODE;

typedef struct sList {
  LISTNODE* first;
  LISTNODE* curr;
  LISTNODE* last;
  long items;
} LINKEDLIST;



BUFFER* NewBuffer(long length);
int DeleteBuffer(BUFFER* Buffer);
LISTNODE* AddItem(LINKEDLIST* list, BUFFER* buffer);
LISTNODE* NewListItem(void);
int DeleteItem(LISTNODE* Node);
LISTNODE* GetStringMatchingListItem(LINKEDLIST* list, char* token);
LINKEDLIST* NewList(void);
int DeleteList(LINKEDLIST* list);
int Length (LINKEDLIST* list);


#endif
