/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef MARGINDISTRIBUTION_H
#define MARGINDISTRIBUTION_H

#include <assert.h>
#include "Object.h"
#include "MLP.h"
#include "DataSet.h"
#include "Criterion.h"
#include "List.h"
#include "OnLineGradient.h"
#include "OLGMTrainer.h"
#include "ClassLLCriterion.h"
#include "MseCriterion.h"
#include "MseMeasurer.h"
#include "ClassMeasurer.h"
#include "TwoClassFormat.h"
#include "OneHotClassFormat.h"
#include "log.h"

namespace Torch {

  typedef struct sMargin {
	real xstart;
	real xwidth;
	long examples;
  } MARGIN;

  typedef struct sMarginDistribution{
	long nofMargins;
	MARGIN* Margin;
	real LowLimit;
	real Width;
	long Dimension;
	long error_rate;
	long examples;
  } MARGIN_DISTRIBUTION;


  // Create a new margin distribution
  MARGIN_DISTRIBUTION* NewMarginDistribution(real lowlimit, real width, long dimension);
  // ** OBSOLETE **
  int AddExample(MARGIN_DISTRIBUTION* MarginDistribution, List* outputs, void* targets, int correct);
  // Measure the distance of two stuff.
  real MeasureDistance(MARGIN_DISTRIBUTION* MarginDistribution, List* y, real* target);
  // Measure the distance of two stuff for multiclass case.
  real MeasureMulticlassDistance(MARGIN_DISTRIBUTION* MarginDistribution, List* y, int TargetClass);
  // Add a distance metric to the histogram
  int AddDistanceToDistribution(MARGIN_DISTRIBUTION* MarginDistribution, real distance);
  // Plot out current output of margin distribution
  int PlotMarginDistribution(MARGIN_DISTRIBUTION* MarginDistribution, char* FileName);
  // Reset the distribution
  int ResetMarginDistribution(MARGIN_DISTRIBUTION* MarginDistribution);
  // Delete the distribution and free stuff
  int DeleteMarginDistribution(MARGIN_DISTRIBUTION* MarginDistribution);
  
}

#endif
