/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/*VER: $Id: MarkovChain.h,v 1.1 2003/02/18 02:27:01 olethros Exp $*/
#ifndef MARKOVCHAIN_H
#define MARKOVCHAIN_H


typedef struct MarkovChain_ {
  int n_states; //number of distinct states
  int mem_size; //history size for new transitions
  int curr_addr; //current address in history
  int tot_states; //total number of representable states (mem_size*n_states)
  float* transitions; //history-wide transition table
  int* memory; //hold history in here
  bool normalized;
} MarkovChain;


/* Creation/deletion */
MarkovChain* NewMarkovChain (int n_states, int mem_size);
int DeleteMarkovChain (MarkovChain* chain);

/* Training and generation */
int MarkovChainTrain (MarkovChain* chain, int state);
int MarkovChainNormalize (MarkovChain* chain);
int MarkovChainReset (MarkovChain* chain);
int MarkovChainGenerate (MarkovChain* chain);

/* Helper functions */  
int MarkovChainCalculateStateID (MarkovChain* chain);
int  MarkovChainPushState (MarkovChain* chain, int state);

/* Debug functions */
int MarkovChainShowTransitions (MarkovChain* chain);

#endif
