/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* $Id: MsgPort.h,v 1.1 2002/11/02 20:13:21 olethros Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "debug.h"

/* 
   This is a message port for communication between
   processes and/or files.

   After setting up the message port function pointers
   it is pretty simple to just call the object to do whatever
   it is supposed to do. A simple macro is also supplied to
   simplify the syntax.
*/

typedef struct MsgPort_ {
  void SndMsg (struct MsgPort_*, void*);
  void* RcvMsg (struct MsgPort_*, void*);
  void ReleasePort(struct MsgPort_*);
  void* RxAddress;
  void* TxAddress;
} MsgPort; 

MsgPort* NewConsoleMsgPort (FILE* file);
void FreeMsgPort (MsgPort* port);
void FreeFileMsgPort (MsgPort* port);
