/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* VER: $Id: PredictorCluster.h,v 1.1 2003/08/21 02:07:56 olethros Exp $ */

#ifndef PREDICTOR_CLUSTER_H
#define PREDICTOR_CLUSTER_H

#include "Predictor.h"

typedef struct PredictorCluster_ {
	int n_clusters;
	Predictor** predictor;
	real* e; //errors
	int T;
	int d;
	int look_ahead;
} PredictorCluster;

PredictorCluster* NewPredictorCluster (int n_inputs, int d, int T, int look_ahead, int n_clusters);
int DeletePredictorCluster (PredictorCluster* pred_clus);
/* Set up */
int PredictorCluster_AddHiddenLayer (PredictorCluster* pred, int n_units);
int PredictorCluster_AddRBFHiddenLayer (PredictorCluster* pred, int n_units);
void PredictorCluster_SetLearningRate (PredictorCluster* pred, real a);
void PredictorCluster_SetBatchMode(PredictorCluster*, bool batch);
int PredictorCluster_Init (PredictorCluster* pred);
void PredictorCluster_SetOutputsToTanH (PredictorCluster* pred);
/* Functionality Interface */
real PredictorCluster_Input(PredictorCluster* predictor, real* x);
real PredictorCluster_Train(PredictorCluster* predictor, real* x);
void PredictorCluster_BatchAdapt(PredictorCluster* pred);
real PredictorCluster_Test(PredictorCluster* predictor, real* x);
real* PredictorCluster_GetOutput(PredictorCluster* predictor);
real PredictorCluster_GetError(PredictorCluster* predictor);

int PredictorCluster_ArgMinErr(PredictorCluster* predictor, real* x);
#endif
