/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* "VER: $Id: SFX.h,v 1.3 2003/09/02 19:24:49 olethros Exp $" */

#ifndef SFX_H
#define SFX_H

#include "TimedStreams.h"

/* SFX provides a dynamically-linked interface to SFX */

/* This is the template for effect class objects */
typedef struct SFX_ {
  struct SFX_* (*NewSFX) (void);
  Sample* (*ApplyToNew) (struct SFX_* sfx, Sample* sample);
  int (*Apply) (struct SFX_* sfx, Sample* sample);
  int (*ApplyToPipe) (struct SFX_* sfx, Sample* sample);
  float (*GetNext)(struct SFX_* sfx);
  int (*ClearPipe) (struct SFX_ sfx);
  int (*DeleteSFX) (struct SFX_ sfx);
  float* current;
  Sample* input_pipe;
} SFX;



SFX* NewSFX(void);
SFX* NewSFXObject(void);
SFX* NewEchoSFX(void);


Sample* SFX_ApplyToNew (struct SFX_* sfx, Sample* sample);
int SFX_Apply (struct SFX_* sfx, Sample* sample);
int SFX_ApplyToPipe (struct SFX_* sfx, Sample* sample);
float SFX_GetNext(struct SFX_* sfx);
int SFX_ClearPipe (struct SFX_ sfx);
int SFX_DeleteSFX (struct SFX_ sfx);


#endif
