/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* "VER: $Id: TimedStreams.c,v 1.2 2003/08/28 00:09:04 olethros Exp $" */

#include "TimedStreams.h"
#include "debug.h"

TimedStream* NewTimedStream (void)
{
  TimedStream* stream;

  stream = AllocM (TimedStream, 1);


  stream->sample = NULL;
  stream->time = 0.0f;
  return stream;
}

TimedStream* NewTimedStream (Sample* sample)
{
  TimedStream* stream = NewTimedStream();
  stream->sample = sample;
  return stream;
}

#define DEFAULT_SAMPLING_RATE 44100
Sample* NewSample (SAMPLE_BUFFER* buffer)
{
  Sample* sample = AllocM (Sample, 1);
  sample->buffer = buffer;
  sample->sampling_rate = DEFAULT_SAMPLING_RATE;
  return sample;
}


MultiStream* NewMultiStream (void)
{
  MultiStream* stream = AllocM (MultiStream, 1);
  if ((stream->stream = List ())==NULL) {
    Serror ("Could not create list!\n");
  }
  return stream;
}

int AddStream (MultiStream* multi, TimedStream* stream)
{
  LIST* list = multi->stream;
  if (ListAppend (list, stream)) {
    return 0;
  } else {
    Serror ("Could not add stream");
    return -1;
  }
}

int RemoveStream (MultiStream* multi, TimedStream* stream)
{
  LISTITEM* item = FindItem (multi->stream, stream);
  return RemoveListItem (multi->stream, item);
}
