/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* "VER: $Id: TimedStreams.h,v 1.1 2003/03/03 10:15:26 olethros Exp $" */

#ifndef TIMEDSTREAMS_H
#define TIMEDSTREAMS_H

#include "SampleBuffer.h"
#include "List.h"
#include "debug.h"

typedef struct Sample_ {
  SAMPLE_BUFFER* buffer; //Holds the data
  float sampling_rate;   //Sampling rate in Hz
} Sample;

typedef struct TimedStream_ {
  Sample* sample; //Holds the sample
  float time;     //Time onset of the sample.
} TimedStream;

typedef struct MultiStream_ {
  LIST* stream;
} MultiStream;
 
TimedStream* NewTimedStream (void);
TimedStream* NewTimedStream (Sample* sample);
Sample* NewSample (SAMPLE_BUFFER* buffer);

MultiStream* NewMultiStream (void);
int AddStream (MultiStream* multi, TimedStream* stream);
int RemoveStream (MultiStream* multi, TimedStream* stream);



#endif
