/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* VER: $Id: VSound.c,v 1.5 2003/08/21 11:57:43 olethros Exp $ */

#include "VSound.h"
#include <time.h>

int main(int argc, char** argv) {
        char* filename = NULL;
  FILE* filestream = NULL;
  Modulator beta = {&mod_sine, 0.0001f, 0.0f, 0.01f, 0.001f};
  Modulator gamma = {&mod_sine, 0.0001f, 0.0f, 0.01f, 0.001f};
  Modulator phase = {&mod_sine, 0.01f, 0.0f, 0.01f, 1.00f};
  //Modulator beta = {&mod_exp_decay, 0.99999f, 1.0f, 0.0f, 0.0f};
  //Modulator gamma = {&mod_exp_decay, 0.99999f, 1.0f, 0.0f, 0.0f};
  Modulator am_synth = {&mod_sine, 0.0001f, 1.0f, 0.0f, 0.8f};
  Modulator exp_decay = {&mod_exp_decay, 0.9999f, 1.0f, 0.0f, 0.0f};

  srand48 (time(NULL));
  
  beta.a = 0.0001*drand48();
  beta.b = 0.0001*drand48();
  beta.c = 0.5*drand48();
  beta.d = 0.5*drand48();
  gamma.a = 0.0001*drand48();
  gamma.b = 0.0001*drand48();
  gamma.c = 0.5*drand48();
  gamma.d = 0.5*drand48();
  
  
  if (argc!=2) {
    return -1;
  }

  filename = argv[1];
  if (WriteFile (filename, filestream)) {
    SAMPLE_BUFFER* buffer = NULL;
    SAMPLE_BUFFER* original = NULL;
    SAMPLE_BUFFER* boing [4]; 
    original = CreateSaw (8.0f, 44100.0f, 440.0f, 0.0001f);
    assert (original);

    AddUniformNoise (original, &exp_decay);
    KernelFilter (original, &beta, &gamma);
    LowPassFilter (original, 0.9f);
    boing[0] = CopyBuffer (original);
    boing[1] = CopyBuffer (original);
    boing[2] = CopyBuffer (original);

    Oscillator (boing[0], 44100.0f, 30.0f, 0.04f);
    Oscillator (boing[1], 44100.0f, 50.0f, 0.04f);
    Oscillator (boing[2], 44100.0f, 70.0f, 0.04f);
    boing[3] = MixBuffers (3, boing, NULL);
    buffer = CopyBuffer (boing[3]);
    for (int ik=0; ik<2; ik++) {
      buffer = MixBuffers (3, boing, NULL);
      FreeSampleBuffer (boing[0]);
      FreeSampleBuffer (boing[1]);
      FreeSampleBuffer (boing[2]);
      boing[0] = CopyBuffer (buffer);
      boing[1] = CopyBuffer (buffer);
      boing[2] = CopyBuffer (buffer);
      FreeSampleBuffer (buffer);
      Oscillator (boing[0], 44100.0f, 40.0f, 0.04f);
      Oscillator (boing[1], 44100.0f, 30.0f, 0.04f);
      Oscillator (boing[2], 44100.0f, 50.0f, 0.04f);
    }
    buffer = MixBuffers (4, boing, NULL);
    for (int j=1; j<=0; j++) {
      for (int i=1; i<128; i*=4) {
        //        am_synth.a = 0.01*drand48();
        //        am_synth.b = drand48();
        //        am_synth.c = drand48();
        //        am_synth.d = drand48();
        phase.a = 0.0001f*drand48();
        phase.c = drand48()*2.0f/((float) i);
        phase.d = 440.0f / ((float) i);
        AddSine (buffer, 44100.0f, &phase, &am_synth);
      }
      for (int i=1; i<0; i*=4) {
        am_synth.a = 0.01*drand48(); 
        am_synth.b = drand48();
        am_synth.c = drand48();
        am_synth.d = drand48();
        phase.a = 0.0001f*drand48();
        phase.c = drand48()*2.0f/((float) i);
        phase.d = 440.0f * ((float) i);
        AddSine (buffer, 44100.0f, &phase, &am_synth);
      }
  
      beta.a = 0.0001*drand48();
      beta.b = 0.0001*drand48();
      beta.c = 0.5*drand48();
      beta.d = 0.5*drand48();
      gamma.a = 0.0001*drand48();
      gamma.b = 0.0001*drand48();
      gamma.c = 0.5*drand48();
      gamma.d = 0.5*drand48();
      //      KernelFilter (buffer, &beta, &gamma);
    }
    //    Oscillator (buffer, 44100.0f, 110.0f, 0.01f);
    ScaleSampleBuffer (buffer);
    SaveSampleBuffer (buffer, filestream);
    FreeSampleBuffer (original);
    FreeSampleBuffer (boing[0]);
    FreeSampleBuffer (boing[1]);
    FreeSampleBuffer (boing[2]);
    FreeSampleBuffer (boing[3]);
    FreeSampleBuffer (buffer);
  } else {
    fprintf (stderr, "Error writing %s\n", filename);
    return -1;
  }
  logmsg ("Exiting\n");
  return 0;
}


float get_beta (int x)
{
  float y = (float) x;
  y = y*0.00004f;  
  return ((1.0f+cos(y))*0.5f);
}

float get_gamma (int x)
{
  float y = (float) x;
  y = y*0.00009f;
  return ((1.0f+sin(y))*0.5f);
}
