/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* "VER: $Id: Vector.h,v 1.3 2003/09/02 19:24:49 olethros Exp $" */

#ifndef VECTOR_H
#define VECTOR_H

#include "debug.h"
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

/* Use this to define an n-dimensional vector */
typedef struct Vector_ {
  int n;
  float* x ;
} Vector;

/* Use this to define an m-by-n matrix */
typedef struct Matrix_ {
  int n; //number of vectors
  Vector* x;
} Matrix;

/* Use this to define an n_1 x n_2 x ... x n_N lattice */
typedef struct Lattice_ {
  int dim; // number of dimensions
  int* n; // number of dimensions per axis
  float* x;
} Lattice;

Vector* NewVector (int n);
int DeleteVector (Vector* vector);


  
#endif /* VECTOR_H */
