/* -*- Mode: C++;  -*- */
/* "VER: $Id: Windowing.h,v 1.2 2003/09/05 01:43:47 olethros Exp $ */

#ifndef WINDOWING_H
#define WINDOWING_H

#include <iostream>
#include "SampleBuffer.h"
#include "TimeStamp.h"

class SampleWindow {
public:
	SampleWindow (long size) {
		N = size;
		tmp = NewSampleBuffer (size);
		printf ("Constructing SampleWindow with constant Buffer\n");
	}
	SampleWindow () {
		N = 0;
		tmp = NULL;
		printf ("Constructing SampleWindow with dynaimc buffer\n");
	}
	virtual ~SampleWindow () {
		if (tmp) {
			printf ("Deleting tmp buffer\n");
			delete tmp;
		}
	}
	void SetSize (long size) {
		if (tmp) {
			FreeSampleBuffer (tmp);
		}
		N = size;
	}
	virtual const SAMPLE_BUFFER* Cut(const SAMPLE_BUFFER* input, TimeStamp start_time, TimeStamp attack) = 0;
	virtual SAMPLE_BUFFER* Cut(const SAMPLE_BUFFER* input, TimeStamp start_time, TimeStamp end_time, TimeStamp attack) = 0;
protected:
	TimeStamp N;
	SAMPLE_BUFFER* tmp;
};

class RectangularWindow : public SampleWindow
{
public:
	RectangularWindow (long size) : SampleWindow (size) {};
	RectangularWindow () {};
	//	virtual ~RectangularWindow() {};
	virtual const SAMPLE_BUFFER* Cut (const SAMPLE_BUFFER* input, TimeStamp start_time, TimeStamp attack);
	virtual SAMPLE_BUFFER* Cut (const SAMPLE_BUFFER* input, TimeStamp start_time, TimeStamp end_time, TimeStamp  attack);
};

class HammingWindow : public SampleWindow
{
public:
	HammingWindow (long size) : SampleWindow (size) {};
	HammingWindow () {};
	//	virtual ~HammingWindow () {};
	virtual const SAMPLE_BUFFER* Cut(const SAMPLE_BUFFER* input, TimeStamp start_time, TimeStamp attack);
	virtual SAMPLE_BUFFER* Cut(const SAMPLE_BUFFER* input, TimeStamp start_time, TimeStamp end_time, TimeStamp attack);
private:
	void Filter (float* src, float* dst, TimeStamp l);
};

#endif
