/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* $Id: datafile.h,v 1.3 2003/08/11 10:07:22 olethros Exp $ */
#ifndef DATAFILE_H
#define DATAFILE_H

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "LinkedList.h"
#include "debug.h"

typedef struct FilePair_ {
  char** input_files;
  char** target_files;
  long n_files;
  long n_dim;
} FilePair;

/* The DATAFILE structure contains summary information about an input
 and output file during a conversion process.  */
typedef struct sDataFile {
  FILE* InputFile;
  FILE* OutputFile;
  long cols;
  long rows;
} DATAFILE;


/* Ok - this is used just to pack the data between conversions -
   should be a bit faster - I hope */
typedef struct sPackData {
  LINKEDLIST* x;
  FILE* FileStream;
  long cols;
  long rows;
  long curr_column;
  BUFFER* temp;
} PACKDATA;
  

DATAFILE* ScanDataFile(char* FileName);
int  SetDimensionsFromString(DATAFILE* DataFile, char* StringBuffer);
int TagsToNumbers(DATAFILE* DataFile, long column);
int DisruptSequenceData(DATAFILE* DataFile, char* prefix, long class_column, long seq_column);

/* Stupid methods for packed data - I cannot believe that I am writing this code! */
void PackDataConvert(PACKDATA* pdata);
PACKDATA* NewPackData(char* filename, long n_columns);
void FreePackData(PACKDATA* pdata);
void PackDataAddElement(PACKDATA* pdata, float token);

/* Reads a list of files into an array */
int readFileList(char* file, FilePair* pairs);
char** readFileList(char* file);
#endif
