/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
const char *MKSEQ_VERSION =  "VER: $Id: mkseq.c,v 1.2 2002/11/04 02:46:18 olethros Exp $";


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "debug.h"
#include "mkseq.h"
#include "string_utils.h"
#include <assert.h>
#include <time.h>
int main(int argc, char* argv[])                          
{
  char* fname;
  int i;
  long seed;  

  seed = time(NULL);
  srand48(seed);
  printf("%s\n",MKSEQ_VERSION);
  printf("Random Seed: %ld\n",seed);
  printf("Called with arguments: ");
  for (i=0;i<argc;i++) {
    printf("[%s]",argv[i]);
  }
  printf("\n");

  if (argc!=3) {
    printf("Two arguments please, for the moment :) \n");
    return -1;
  }

  fname = argv[1];
  printf("\n");
  for (i=1;i<=2;i++) {
    fname = argv[i];
    printf("Writing set: %s\n",fname);
    if (ShowError(WriteSequences(fname,32))) {
      printf("Exiting prematurely.\n");
      return -1;
    }
  }
  printf("Done\n");
  return 0;
}

//=============================================================================
// WriteSequences() - Generate and write a number of sequences to the file
//-----------------------------------------------------------------------------
/* 
   DESCRIPTION
   - Generate #maxseq# sequences and write the results to #fname#.
*/
//----------------------------------------------------------------------------
int WriteSequences(char* fname, int maxseq) {
  int n;
  FILE* f;
  long seql = 512;
  SAMPLE_BUFFER** b = NULL;
  SAMPLE_BUFFER* sequence = NULL;
  float frequency = 200.0f + 20.0f * ((float) drand48 ());
  printf ("Frequency :%f\n",frequency);
  if (!(WriteFile(fname,f))) {
    Serror("Could not write to file %s",fname);
    return (DEC_ARG_CORRUPT|1);
  }
    
  b = AllocM (SAMPLE_BUFFER*, maxseq);
  if (!b) {
    CloseFile (f);
    Serror ("Could not allocate shit!");
    return -1;
  }

  for (n=0; n<maxseq; n++) {
    b[n] = CreateSine (seql, 8000.0f, frequency, 0.2f);
    AddUniformNoise (b[n], 0.2f + 0.2f * ((float) drand48()));
  }

  /* Create a multi-dimensional sequence to save the data in */
  sequence = InterleaveBuffers(b, maxseq);
  if (sequence) {
    printf ("Saving sequence of length %ld\n",sequence->length);
    SaveSampleBuffer (sequence, f);
    FreeSampleBuffer (sequence);
  } else {
    Serror ("Could create interleaved sequence\n");
  }
    
  for (n=0; n<maxseq; n++) {
    FreeSampleBuffer (b[n]);
  }
  FreeM(b);

  CloseFile(f);
  
  
  
  return 0;
} /* int WriteSequences () */

 


  
