/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* "VER: $Id: psr.h,v 1.8 2003/09/03 11:36:50 olethros Exp $" */


#ifndef PSR_H
#define PSR_H

#include "SampleBuffer.h"
#include "modulator.h"
#include "Vector.h"
#include "TimeStamp.h"

typedef struct Filter_ {
  Vector* a;
  Vector* b;
} Filter;


SAMPLE_BUFFER* CreateSine (long length, float r, float f, float a);
SAMPLE_BUFFER* CreateSine (float length, float r, float f, float a);
SAMPLE_BUFFER* CreatePulse (long length, float r, float f, float a);
SAMPLE_BUFFER* CreatePulse (float length, float r, float f, float a);
SAMPLE_BUFFER* CreateSaw (long length, float r, float f, float a);
SAMPLE_BUFFER* CreateSaw (float length, float r, float f, float a);
SAMPLE_BUFFER* CreatePseudoRandomSequence(long length, float p);
SAMPLE_BUFFER* CreatePseudoRandomSequence(long length, float p);
int AddUniformNoise(SAMPLE_BUFFER* sample, float amplitude);
int AddUniformNoise(SAMPLE_BUFFER* sample, Modulator* a);
SAMPLE_BUFFER* AddSine(SAMPLE_BUFFER* buf, float r, Modulator* f, Modulator* a);
SAMPLE_BUFFER* KernelFilter (SAMPLE_BUFFER* sample, Modulator* beta,
                             Modulator* gamma);
SAMPLE_BUFFER* LowPassFilter (SAMPLE_BUFFER* sample, float damp);
SAMPLE_BUFFER* Oscillator (SAMPLE_BUFFER* sample, float r, float f, float d);
SAMPLE_BUFFER* VolumeRamp (SAMPLE_BUFFER* sample, TimeStamp start, TimeStamp end, float boost_a, float boost_b);
SAMPLE_BUFFER* VolumeRamp (SAMPLE_BUFFER* sample, float r, float start, float end, float boost_a, float boost_b);
SAMPLE_BUFFER* IIRFilter (SAMPLE_BUFFER* sample, Filter* parameters);

#endif /* PSR_H */

