/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/*
  replace_letters.c - Copyright (C) 2002 Christos Dimitrakakis

  DESCRIPTION
  - This very simple source is useful to convert a simple letter-tagged
  datafile into a number-tagged one.

  SEE ALSO
  - tag2num.c

*/

#include <stdio.h>
#include <assert.h>

#define ReadFile(f,fs) ((fs=fopen(f,"r"))!=NULL)
#define CloseFile(f) {assert(f); fclose(f); f = NULL;}


int main(int argc, char* argv[])
{
  char* f = NULL;
  FILE* fs = NULL;

  if (argc!=2) {
    fprintf(stderr,"USAGE: replace_letters <file>\n");
    goto QUICK_EXIT;
  }

  f = argv[1];

  if (ReadFile(f,fs)) {
    register char c = '\0';
    while (c!=EOF) {
      c = fgetc(fs);
      if (c!=EOF) {
	if ((c>='A')&&(c<='Z')) {
	  c = c - 'A';
	  printf("%d",c);
	}else{
	  printf("%c",c);
	}		
      }
    }
    CloseFile(fs);
  }

  printf("Exiting OK\n");
  return 0;

 QUICK_EXIT:
  if (fs) 
    CloseFile(fs);
  
  return -1;
}
