#include "SIMOBuffer.h"
/* 
 A small test. The writer writes to 0-1 and then to 2-3, 4-5, etc.
 The reader reads fro 0-3 and then from 1-4, 2-5, 3-6, etc.
 Since the buffer has length of 32, the writer finishes at
 32-34, while the reader should be around 3-7.
 */
typedef SIMOBuffer<float> Buf;
typedef IOPort<float> Port;

void Read_Ack (Port* p);
void Write_Ack (Port* p);
int main ()
{
	Buf cbuffer(1, 32);
	Port* write;
	Port* read;
	
	write = cbuffer.WritePort_Req();
	read = cbuffer.ReadPort_Req();

	write->Ack = &Write_Ack;
	read->Ack = &Read_Ack;
	
	write->tail += 2;
	read->tail += 3;
	for (int i=0; i<10; i++) {
		cbuffer.IO_Req (write);
		cbuffer.IO_Req (read);
	}
	return 0;
}

void Read_Ack (Port* p)
{
	std::cout << "Read: ";
	for (float* x = p->head; x<p->tail; x++) {
		std::cout << *x << " ";
	}
	std::cout << std::endl;  
	p->head++;
	p->tail++;
}

void Write_Ack (Port* p)
{
	std::cout << "Writing: ";
	float value = drand48();
	for (float* x = p->head; x < p->tail; x++) {
		*x = value;
		std::cout << *x << " ";
		value += 1.0;
	}
	std::cout << std::endl;
	p->tail += 2;
	p->head += 2;
}
