/* -*- Mode: C++ -*- */
/* $Id: test_seg.c,v 1.2 2003/08/29 00:35:42 olethros Exp $
 *
 * AUTHORS AND COPYRIGHT
 *
 * Copyright (C) 2003, Christos Dimitrakakis
 * 
 * This code can be freely distributed under the GNU General Public
 * License. See file COPYING for details.
 * 
 * DESCRIPTION
 *
 * A simple test of the SegmentedSample collection of routines,
 * obeying the USAGE section defined therein
 *
 */

#include "SegmentedSample.h"

int main (int argc, char** argv) 
{
     LINKEDLIST* labels;
     SegmentList* seg;
     SAMPLE_BUFFER_LIST* buffers;
     if (argc!=4) {
       fprintf (stderr, "Usage:\ntest_seg label_list segmentation_list wav_file\n");
       exit (-1);
     }
     // We need some label names first.
     labels = LoadHTKLabels (argv[1]); 
     // Load a segmentation file
     seg = LoadHTKSegmentation (argv[2], labels); 
     // Read a sample in segments, according to the given segmentation
     buffers = LoadSampleSegments (argv[3], seg, TIME_UNITS_MS); 
     // Show us the list of segments.
     ShowSegmentation (seg);
     FreeBufferList (buffers);
     FreeSegmentList (seg);
     DeleteList (labels);
     return 0;
}
